

%% Sample: Exponential Moving Average (EMA)

-module (sb_aggregate_fn_ema2).
-behaviour(sb_aggregate_fn).
-export([init/1,accumulate/2,emit/1]).

init(_State) -> {[], [], 100.0}.

accumulate(State,{A,Weight,Capacity}) -> 
	{Values,Weights,W} = State,
    Exp = W * (1.0 - Weight),
	{ bounded_list:append(Values,A,Capacity),
          bounded_list:append(Weights,W,Capacity),
          Exp }.

emit(State) -> 
	{Values,Weights, _W} = State,
	lists:sum([ V * VW || {V, VW} <- lists:zip(lists:reverse(Values),Weights)])/lists:sum(Weights).


