package com.streambase.contrib.erjang.impl;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Tuple;
import com.streambase.sb.client.CustomFunctionResolver;
import com.streambase.sb.operator.AggregateWindow;

import erjang.EDouble;
import erjang.EObject;

/**
 * Generated by JDT StreamBase Client Templates (Version: 7.0.1.1012141737).
 *
 * All custom java aggregate classes must extend AggregateWindow. The user's subclass
 * must implement an accumulate method that corresponds to the argument number and
 * data types that the calljava expression in the Aggregate operator refers to. 
 * The user's subclass must also implement a calculate method. When data is sent from 
 * the aggregate window, the calculate method must return a type mapping to a StreamBase data 
 * type: int, Integer, double, Double, Timestamp, byte [], or String. 
 * The AggregateWindow object is likely to be used several times. At the start of each 
 * new use, the init() method will be called. Then accumulate and calculate may be called.
 * Finally, at the end of each use, release will be called. 
 * They may also be aliased for use as if that function were embedded in 
 * your StreamBase application by using the alias attribute within the <custom-functions> section
 * of the StreamBase Server configuration file.
 * <p>
 * For in-depth information on implementing a a StreamBase aggregate function, please see some
 * related topics from "Developing StreamBase Custom Functions" in the StreamBase 
 * documentation.
 * For more information on using aliases, please see the <custom-functions> section from 
 * "StreamBase Server Configuration XML" in the StreamBase documentation.
 * <p>
 */
@SuppressWarnings("serial")



public class ErjangAggregateFunction extends AggregateWindow {	
	private EObject state;
	private String m;
	private Tuple h;

	// Called before a new window opens
	public void init() { }

	// Called when a tuple emission policy fires
	public Tuple calculate() {
		return SimpleEmbedded.callerl_emit(m, state, h);
	}

	@CustomFunctionResolver("accumulateCustomFunctionResolver0")
	public void accumulate(String mod, Tuple args, Tuple hint) {
		if (state == null) {
			state = SimpleEmbedded.callerl_init(mod, new EDouble(0));
			m = mod; h = hint; // Type Hint. Ensure 'free form' erlang tuple conforms with SB tuple's schema
		}
		state = SimpleEmbedded.callerl_accumulate(m, state, args, hint);
	}

	public static CompleteDataType accumulateCustomFunctionResolver0(
			CompleteDataType mod, CompleteDataType args, CompleteDataType hint) {
		return hint; // Keep the StreamBase type checking police happy!
	}

	public void release() {
		state = null;
	}
}
