package com.streambase.contrib.erjang.impl;


import com.streambase.sb.CompleteDataType;
import com.streambase.sb.StreamBaseRuntimeException;
import com.streambase.sb.Tuple;
import com.streambase.sb.client.CustomFunctionResolver;

/**
 * Generated by JDT StreamBase Client Templates (Version: 7.0.1.1012141737).
 *
 * All custom java simple functions must live in a public Java class as a public static method.
 * Custom Java simple functions can be accessed by the simple form of calljava in any expression
 * except in aggregate functions.
 * They may also be aliased for use as if that function were embedded
 * in your StreamBase Application by using the alias attribute within
 * the <custom-functions> section in the StreamBase Server configuration file.
 * <p>
 * For in-depth information on implementing a StreamBase simple function, please see some
 * related topics from "Developing StreamBase Custom Functions" in the StreamBase 
 * documentation.
 * For more information on using aliases, please see the <custom-functions> section from 
 * "StreamBase Server Configuration XML" in the StreamBase documentation.
 * <p>
 */
public class ErjangSimpleFunction {

	/**
	 * A StreamBase Simple Function. Use this function
	 * in StreamBase expressions using the <em>calljava</em> function, or 
	 * by an assigned alias. It can then be called directly 
	 * using the alias name instead of using calljava().
	 */
	@CustomFunctionResolver("callerlCustomFunctionResolver0")
	public static Tuple callerl(String mod, Tuple args, Tuple hint) {
		try {
			return SimpleEmbedded.callerl(mod,args);
		} catch(Throwable t) {
			throw new StreamBaseRuntimeException(t);
		}
	}

	/**
	 * A StreamBase Custom Function Resolver Function. This method is used by 
	 * StreamBase for type checking.  Use this method
	 * to resolve functions that take lists or tuples as arguments 
	 * or return lists or tuples.  This method should be used to ensure the 
	 * data types of your function are correct.
	
	 * For custom functions that return simple types (the Java equivalents of the simple 
	 * StreamBase types: int, long, double, bool, string, blob, timestamp), the returned CompleteDataType
	 * must be the appropriate corresponding simple type (e.g., as returned by CompleteDataType.forInt()).
	 * For custom functions that return non-simple types (the Java equivalents of the non-simple
	 * StreamBase types: tuple, list), the returned CompleteDataType must fully describe the appropriate
	 * non-simple type (as returned by CompleteDataType.forTuple(Schema) or CompleteDataType.forList(CompleteDataType))
	 *{@see com.streambase.sb.client.CustomFunctionResolver}  
	 */
	public static CompleteDataType callerlCustomFunctionResolver0(
			CompleteDataType mod, CompleteDataType args, CompleteDataType hint) {
		return hint;
	}

}
